//----------------------------------------------------------------------------------
//aviutlvOC@filed_mov
//
//----------------------------------------------------------------------------------
#include <windows.h>
#include <math.h>

#include "filter.h"
//#include "rdtsc.h"


//---------------------------------------------------------------------
//tB^\̒`
//---------------------------------------------------------------------
#define TRACK_N 8 //gbNo[̐
TCHAR *track_name[] = {"c(TOP)", "(TOP)", "c(BOT)", "(BOT)",
                       "c", "", "", "" }; //gbNo[̖O
int   track_default[] = { 0, 0, 0, 0, 0, 0, 480, 640 }; //gbNo[̏l
int   track_s[] = { -256, -256, -256, -256, 0, 0, 1, 1 }; //gbNo[̉l
int   track_e[] = {  256,  256,  256,  256, 2048, 2048, 2048, 2048}; //gbNo[̏l
enum  { T_VT, T_HT, T_VB, T_HB, T_V, T_H, T_HEIGHT, T_WIDTH };

#define CHECK_N 4 //`FbN{bNX̐
TCHAR *check_name[] = { "[̏", "60fps", "tB[h]","͈͂̕\" }; //`FbN{bNX̖O
int    check_default[] = { 0, 0, 0, 0 }; //`FbN{bNX̏l (l01)
enum { C_EDG, C_60FPS, C_FIELD, C_DISP };

FILTER_DLL filter = {
  FILTER_FLAG_EX_INFORMATION, //| FILTER_FLAG_WINDOW_SIZE, //tB^̃tO
  0,0,                        //ݒEChẼTCY (FILTER_FLAG_WINDOW_SIZEĂ鎞ɗL)
  "tB[hʈʒuړ", //tB^̖O
  TRACK_N,                    //gbNo[̐ (0Ȃ疼OlNULLł悢)
  track_name,                 //gbNo[̖OSւ̃|C^
  track_default,              //gbNo[̏lSւ̃|C^
  track_s,track_e,            //gbNo[̐l̉ (NULLȂS0`256)
  CHECK_N,                    //`FbN{bNX̐ (0Ȃ疼OlNULLł悢)
  check_name,                 //`FbN{bNX̖OSւ̃|C^
  check_default,              //`FbN{bNX̏lSւ̃|C^
  func_proc,                  //tB^֐ւ̃|C^ (NULLȂĂ΂܂)
  NULL,                  //JnɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
  NULL,                       //IɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
  NULL,                       //ݒ肪ύXꂽƂɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
  NULL,                       //ݒEBhEɃEBhEbZ[WɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
  NULL,NULL,                  //VXeŎg܂̂ŎgpȂł
  NULL,                       //  gf[^̈ւ̃|C^ (FILTER_FLAG_EX_DATAĂ鎞ɗL)
  0,                       //  gf[^TCY (FILTER_FLAG_EX_DATAĂ鎞ɗL)
  "filed move by N099, ver1.0",  //  tB^ւ̃|C^ (FILTER_FLAG_EX_INFORMATIONĂ鎞ɗL)
  NULL,                       //Z[uJn钼OɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
  NULL,                       //Z[uIOɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)

};

#define PI 3.141592653589793238462643383279

int make_coeff(int[], int);
int disp(FILTER *,FILTER_PROC_INFO *);
int mov_v(FILTER *,FILTER_PROC_INFO *, int, int);
int mov_h(FILTER *,FILTER_PROC_INFO *, int, int);

int cvt[4];
int cht[4];
int cvb[4];
int chb[4];

//---------------------------------------------------------------------
//     tB^\̂̃|C^n֐
//---------------------------------------------------------------------
EXTERN_C FILTER_DLL __declspec(dllexport) * __stdcall GetFilterTable( void )
{
  return &filter;
}


//---------------------------------------------------------------------
// tB^֐
//---------------------------------------------------------------------
BOOL func_proc( FILTER *fp,FILTER_PROC_INFO *fpip )
{
//
//	fp->track[n]			: gbNo[̐l
//	fp->check[n]			: `FbN{bNX̐l
//	fpip->w 				: ۂ̉摜̉
//	fpip->h 				: ۂ̉摜̏c
//	fpip->max_w				: 摜̈̉
//	fpip->max_h				: 摜̈̏c
//	fpip->ycp_edit			: 摜̈ւ̃|C^
//	fpip->ycp_temp			: e|̈ւ̃|C^
//	fpip->ycp_edit[n].y		: f(Px    )f[^ (     0 ` 4095 )
//	fpip->ycp_edit[n].cb	: f(F())f[^ ( -2048 ` 2047 )
//	fpip->ycp_edit[n].cr	: f(F())f[^ ( -2048 ` 2047 )
//
//  ff[^͔͈͊OɏoĂ邱Ƃ܂B
//  ܂͈͓Ɏ߂ȂĂ܂܂B
//
//	摜TCYςƂ fpip->w  fpip->h ς܂B
//
//	e|̈ɏ摜i[Ƃ
//	fpip->ycp_edit  fpip->ycp_temp ւ܂B
//

  static int vt,ht,vb,hb;
  int i;

  // WvZ
  if(vt != fp->track[T_VT]){
    i = fp->track[T_VT];
    make_coeff(cvt, i);
    vt = fp->track[T_VT];
  }
  if(ht != fp->track[T_HT]){
    i = fp->track[T_HT];
    make_coeff(cht, i);
    ht = fp->track[T_HT];
  }
  if(vb != fp->track[T_VB]){
    i = fp->track[T_VB];
    make_coeff(cvb, i);
    vb = fp->track[T_VB];
  }
  if(hb != fp->track[T_HB]){
    i = fp->track[T_HB];
    make_coeff(chb, i);
    hb = fp->track[T_HB];
  }

  i = fpip->frame & 0x1;
  if(fpip->flag | FILTER_PROC_INFO_FLAG_INVERT_FIELD_ORDER) //gbvt@[Xg
    i = -(i-1);
  if(fp->check[C_FIELD]) // ]
    i = -(i-1);

  // top (i==0)
  if(!(fp->check[C_60FPS] && i) && (ht || vt)){
    mov_h(fp, fpip, ht, 0);
    mov_v(fp, fpip, vt, 0);
  }

  // bot (i==1)
  if((!fp->check[C_60FPS] || i) && (hb || vb)){
    mov_h(fp, fpip, hb, 1);
    mov_v(fp, fpip, vb, 1);
  }
    
  // ͈͂̕\
  if(fp->check[C_DISP] && fp->exfunc->is_editing(fpip->editp)){
    disp(fp, fpip);
  }
  
  return TRUE;
}

//W̌vZ 4tap lanczos2
//81fPʂƂ
//W15biťŒ菬
// [A] cof[0],cof[1], (߂_), cof[2], cof[3] Ƃʒu֌W
int make_coeff(int cof[4], int offset)
{
  int i,j;
  double a,b;
  double sum = 0.0;
  double c[4];
    
  
  j = abs(offset)%8;
  if(0 == j){
    cof[0] = cof[2] = cof[3] = 0;
    cof[1] = 1<<15;
    return 0;
  }

  if(offset>0){
    offset = 8 - j;
  }else{
    offset = j;
  }
  
  __asm {
    emms;
  }

  for (i=0;i<4;++i){
    a = PI * ((i-1) - offset/8.0);
    b = sin(a)/a;
    a /= 2.0;
    b *= sin(a)/a;
    c[i] = b;
    sum += b;
  }
  
  if (sum <= 0.0)
    return 1;
  
  for (i=0;i<4;++i){
    c[i] /= sum;
    c[i] *= 1<<15;
    cof[i] = c[i];
  }

  return 0;
}

//̈ړ
//int off ItZbg1/8sNZP
//int f   tB[h f==0TOP
int mov_v(FILTER *fp,FILTER_PROC_INFO *fpip, int off, int f)
{
  int i,j,k,l;
  int k0, k1, k2, k3;
  int tmp;
  int v,vh;
  int h,hw;
  int *c;
  PIXEL_YC *dst, *src;
  PIXEL_YC yctmp;

  v = fp->track[T_V];
  v = v >= 0 ? v : 0;
  vh = v + fp->track[T_HEIGHT];
  vh = vh <= fpip->h ? vh : fpip->h;
  h = fp->track[T_H];
  h = h >= 0 ? h : 0;
  hw = h + fp->track[T_WIDTH];
  hw = hw <= fpip->w ? hw : fpip->w;

  c = f ? cvb : cvt;

  //ړ
  k = off>0 ? -(off-1)/8 - 1: -off/8;
  k *= 2;
  l = fpip->max_w;
  if(abs(off)%8){ //TusNZvZ
    for(i=f; i<fpip->h; i+=2){
      dst = fpip->ycp_edit + i*l;
      src = fpip->ycp_temp + i*l;
      k1 = i + k; //
      k2 = k1 + 2; //
      
      if(i<v || i>=vh){ // ͈͊O͂̂܂
        memcpy(dst, src, sizeof(PIXEL_YC)*l);
      }else if(k2<v || k1>=vh){
        if(fp->check[C_EDG]){ //[̏
          k0 = i > 0 ? -l : l;
          k1 = i+1 < fpip->h ? l : k0;
          for(j=0; j<fpip->w; ++j){
            if(j<h || j>=hw){
              *dst = *src;
            }else{
              yctmp.y = ((dst+k0)->y + (dst+k1)->y)>>1;
              yctmp.cb = ((dst+k0)->cb + (dst+k1)->cb)>>1;
              yctmp.cr = ((dst+k0)->cr + (dst+k1)->cr)>>1;
              *dst = yctmp;
            }
            ++src;
            ++dst;
          }
        }else{
          memcpy(dst, src, sizeof(PIXEL_YC)*l);
        }
      }else{
        k1 = k1>=0 ? k : k+2;
        k0 = i + k - 2;
        k0 = k0>=0 ? k-2 : k1;
        k2 = k2<fpip->h ? k+2 : k;
        k3 = i + k + 4;
        k3 = k3<fpip->h ? k+4 : k2;
        k0 *= l;
        k1 *= l;
        k2 *= l;
        k3 *= l;
        for(j=0; j<fpip->w; ++j){
          if(j<h || j>=hw){
            *dst = *src;
          }else{
            tmp = c[0]*(src+k0)->y + c[1]*(src+k1)->y + c[2]*(src+k2)->y + c[3]*(src+k3)->y;
            yctmp.y  = tmp/(1<<15);
            tmp = c[0]*(src+k0)->cb + c[1]*(src+k1)->cb + c[2]*(src+k2)->cb + c[3]*(src+k3)->cb;
            yctmp.cb = tmp/(1<<15);
            tmp = c[0]*(src+k0)->cr + c[1]*(src+k1)->cr + c[2]*(src+k2)->cr + c[3]*(src+k3)->cr;
            yctmp.cr = tmp/(1<<15);
            *dst = yctmp;
          }
          
          ++src;
          ++dst;
        }
      }
    }
  }else{
    for(i=f; i<fpip->h; i+=2){
      dst = fpip->ycp_edit + i*l;
      src = fpip->ycp_temp + i*l;
      k0 = i+k;

      if(i<v || i>=vh){ // ͈͊O͂̂܂
        memcpy(dst, src, sizeof(PIXEL_YC)*l);
      }else if(k0<v || k0>=vh){
        if(fp->check[C_EDG]){ //[̏
          k0 = i > 0 ? -l : l;
          k1 = i+1 < fpip->h ? l : k0;
          for(j=0; j<fpip->w; ++j){
            if(j<h || j>=hw){
              *dst = *src;
            }else{
              yctmp.y = ((dst+k0)->y + (dst+k1)->y)>>1;
              yctmp.cb = ((dst+k0)->cb + (dst+k1)->cb)>>1;
              yctmp.cr = ((dst+k0)->cr + (dst+k1)->cr)>>1;
              *dst = yctmp;
            }
            ++src;
            ++dst;
          }
        }else{
          memcpy(dst, src, sizeof(PIXEL_YC)*l);
        }
      }else{
        for(j=0; j<fpip->w; ++j){
          *dst = (j<h || j>=hw) ? *src : *(src+l*k);

          ++src;
          ++dst;
        }
      }
    }
  }
  
  return 0;
}

//̈ړ
int mov_h(FILTER *fp,FILTER_PROC_INFO *fpip, int off, int f)
{
  int i,j,k;
  int k0, k1, k2, k3;
  int l0, l1;
  int tmp;
  int v,vh;
  int h,hw;
  int *c;
  PIXEL_YC *dst, *src;
  PIXEL_YC yctmp;

  v = fp->track[T_V];
  v = v >= 0 ? v : 0;
  vh = v + fp->track[T_HEIGHT];
  vh = vh <= fpip->h ? vh : fpip->h;
  h = fp->track[T_H];
  h = h >= 0 ? h : 0;
  hw = h + fp->track[T_WIDTH];
  hw = hw <= fpip->w ? hw : fpip->w;

  c = f ? chb : cht;
  k = off>0 ? -(off-1)/8 - 1: -off/8;
  
  if(abs(off)%8){ //TusNZvZ
    for(i=f; i<fpip->h; i+=2){
      dst = fpip->ycp_temp + i*fpip->max_w;
      src = fpip->ycp_edit + i*fpip->max_w;
      l0 = i-1 >= 0 ? -fpip->max_w : fpip->max_w;
      l1 = i+1 < fpip->h ? fpip->max_w : l0;
      if(i<v || i>=vh){ // ͈͊O͂̂܂
        memcpy(dst, src, sizeof(PIXEL_YC)*fpip->max_w);
      }else{
        for(j=0; j<fpip->w; ++j){
          k1 = j+k;
          k2 = k1+1;
          if(j<h || j>=hw){ // ͈͊O͂̂܂
            *dst = *src;
          }else if(k2<h || k1>=hw){
            if(fp->check[C_EDG]){ //[̏
              yctmp.y = ((src+l0)->y + (src+l1)->y)>>1;
              yctmp.cb = ((src+l0)->cb + (src+l1)->cb)>>1;
              yctmp.cr = ((src+l0)->cr + (src+l1)->cr)>>1;
              *dst = yctmp;
            }else{
              *dst = *src;
            }
          }else{
            k1 = k1>=0 ? k : k+1;
            k0 = j+k-1>=0 ? k-1 : k1;
            k2 = k2<fpip->w ? k+1 : k;
            k3 = j+k+2<fpip->w ? k+2 : k2;
            tmp = c[0]*(src+k0)->y + c[1]*(src+k1)->y + c[2]*(src+k2)->y + c[3]*(src+k3)->y;
            yctmp.y  = tmp/(1<<15);
            tmp = c[0]*(src+k0)->cb + c[1]*(src+k1)->cb + c[2]*(src+k2)->cb + c[3]*(src+k3)->cb;
            yctmp.cb = tmp/(1<<15);
            tmp = c[0]*(src+k0)->cr + c[1]*(src+k1)->cr + c[2]*(src+k2)->cr + c[3]*(src+k3)->cr;
            yctmp.cr = tmp/(1<<15);
            *dst = yctmp;
          }
          ++src;
          ++dst;
        }
      }
    }
  }else{
    for(i=f; i<fpip->h; i+=2){
      dst = fpip->ycp_temp + i*fpip->max_w;
      src = fpip->ycp_edit + i*fpip->max_w;
      l0 = i-1 >= 0 ? -fpip->max_w : fpip->max_w;
      l1 = i+1 < fpip->h ? fpip->max_w : l0;
      if(i<v || i>=vh){ // ͈͊O͂̂܂
        memcpy(dst, src, sizeof(PIXEL_YC)*fpip->max_w);
      }else{
        for(j=0; j<fpip->w; ++j){
          if(j<h || j>=hw){ // ͈͊O͂̂܂
            *dst = *src;
          }else if(j+k<h || j+k>=hw){
            if(fp->check[C_EDG]){ //[̏
              yctmp.y = ((src+l0)->y + (src+l1)->y)>>1;
              yctmp.cb = ((src+l0)->cb + (src+l1)->cb)>>1;
              yctmp.cr = ((src+l0)->cr + (src+l1)->cr)>>1;
              *dst = yctmp;
            }else{
              *dst = *src;
            }
          }else{
            *dst = *(src+k);
          }
          ++src;
          ++dst;
        }
      }
    }
  }
  return 0;
}

//͈͂̕\
int disp(FILTER *fp,FILTER_PROC_INFO *fpip)
{
  int i,j;
  int v,vh;
  int h,hw;
  PIXEL_YC *ptr;

  v = fp->track[T_V];
  vh = v + fp->track[T_HEIGHT];
  h = fp->track[T_H];
  hw = h + fp->track[T_WIDTH];
  
  for(i=v; i<fpip->h && i<=vh; i++){
    ptr = fpip->ycp_edit + i*fpip->max_w;
    for(j=0; j<fpip->w; ++j){
      if(j>=h && j<=hw){
        ptr->y  = 4095 - ptr->y;
        ptr->cr = - ptr->cr;
        ptr->cb = - ptr->cb;
      }
      ++ptr;
    }
  }

  return 0;
}

